// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: ui_controller_service.proto

package com.android.emulator.control;

/**
 * <pre>
 * The pixel coordinates are resolution independent, meaning the coordinates
 * are independent from the pixel grid, resulting in a graphical user
 * interface that is displayed at a consistent location, regardless of the
 * resolution of the screen.
 *
 * For technical details: https://doc.qt.io/qt-5/highdpi.html
 *
 * Some things to note:
 *
 * - You cannot move a window offscreen.
 * - There is a padding of around 10px around the frame.
 *
 * This means that moving to (0, 0) or (10, 10) will have the same result.
 * This means that anchoring might not exactly behave as requested.
 * </pre>
 *
 * Protobuf type {@code android.emulation.control.WindowPosition}
 */
public final class WindowPosition extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:android.emulation.control.WindowPosition)
    WindowPositionOrBuilder {
private static final long serialVersionUID = 0L;
  // Use WindowPosition.newBuilder() to construct.
  private WindowPosition(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private WindowPosition() {
    horizontalAnchor_ = 0;
    verticalAnchor_ = 0;
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new WindowPosition();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.android.emulator.control.UiControllerService.internal_static_android_emulation_control_WindowPosition_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.android.emulator.control.UiControllerService.internal_static_android_emulation_control_WindowPosition_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.android.emulator.control.WindowPosition.class, com.android.emulator.control.WindowPosition.Builder.class);
  }

  /**
   * <pre>
   * Anchor that is used to determine horizontal window placement.
   * </pre>
   *
   * Protobuf enum {@code android.emulation.control.WindowPosition.HorizontalAnchor}
   */
  public enum HorizontalAnchor
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <pre>
     * The x coordinate will be treated as the left edge of the
     * </pre>
     *
     * <code>LEFT = 0;</code>
     */
    LEFT(0),
    /**
     * <pre>
     * window.
     * </pre>
     *
     * <code>HCENTER = 1;</code>
     */
    HCENTER(1),
    /**
     * <pre>
     * the left and right edges of the window.
     * </pre>
     *
     * <code>RIGHT = 2;</code>
     */
    RIGHT(2),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * The x coordinate will be treated as the left edge of the
     * </pre>
     *
     * <code>LEFT = 0;</code>
     */
    public static final int LEFT_VALUE = 0;
    /**
     * <pre>
     * window.
     * </pre>
     *
     * <code>HCENTER = 1;</code>
     */
    public static final int HCENTER_VALUE = 1;
    /**
     * <pre>
     * the left and right edges of the window.
     * </pre>
     *
     * <code>RIGHT = 2;</code>
     */
    public static final int RIGHT_VALUE = 2;


    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static HorizontalAnchor valueOf(int value) {
      return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static HorizontalAnchor forNumber(int value) {
      switch (value) {
        case 0: return LEFT;
        case 1: return HCENTER;
        case 2: return RIGHT;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<HorizontalAnchor>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        HorizontalAnchor> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<HorizontalAnchor>() {
            public HorizontalAnchor findValueByNumber(int number) {
              return HorizontalAnchor.forNumber(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalStateException(
            "Can't get the descriptor of an unrecognized enum value.");
      }
      return getDescriptor().getValues().get(ordinal());
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return com.android.emulator.control.WindowPosition.getDescriptor().getEnumTypes().get(0);
    }

    private static final HorizontalAnchor[] VALUES = values();

    public static HorizontalAnchor valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      if (desc.getIndex() == -1) {
        return UNRECOGNIZED;
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private HorizontalAnchor(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:android.emulation.control.WindowPosition.HorizontalAnchor)
  }

  /**
   * <pre>
   * Anchor that is used to determine vertical window placement.
   * </pre>
   *
   * Protobuf enum {@code android.emulation.control.WindowPosition.VerticalAnchor}
   */
  public enum VerticalAnchor
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <pre>
     * The y coordinate will be treated as the top edge of the
     * </pre>
     *
     * <code>TOP = 0;</code>
     */
    TOP(0),
    /**
     * <pre>
     * window.
     * </pre>
     *
     * <code>VCENTER = 1;</code>
     */
    VCENTER(1),
    /**
     * <pre>
     * the top and bottom edges of the window.
     * </pre>
     *
     * <code>BOTTOM = 3;</code>
     */
    BOTTOM(3),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * The y coordinate will be treated as the top edge of the
     * </pre>
     *
     * <code>TOP = 0;</code>
     */
    public static final int TOP_VALUE = 0;
    /**
     * <pre>
     * window.
     * </pre>
     *
     * <code>VCENTER = 1;</code>
     */
    public static final int VCENTER_VALUE = 1;
    /**
     * <pre>
     * the top and bottom edges of the window.
     * </pre>
     *
     * <code>BOTTOM = 3;</code>
     */
    public static final int BOTTOM_VALUE = 3;


    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static VerticalAnchor valueOf(int value) {
      return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static VerticalAnchor forNumber(int value) {
      switch (value) {
        case 0: return TOP;
        case 1: return VCENTER;
        case 3: return BOTTOM;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<VerticalAnchor>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        VerticalAnchor> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<VerticalAnchor>() {
            public VerticalAnchor findValueByNumber(int number) {
              return VerticalAnchor.forNumber(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalStateException(
            "Can't get the descriptor of an unrecognized enum value.");
      }
      return getDescriptor().getValues().get(ordinal());
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return com.android.emulator.control.WindowPosition.getDescriptor().getEnumTypes().get(1);
    }

    private static final VerticalAnchor[] VALUES = values();

    public static VerticalAnchor valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      if (desc.getIndex() == -1) {
        return UNRECOGNIZED;
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private VerticalAnchor(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:android.emulation.control.WindowPosition.VerticalAnchor)
  }

  public static final int X_FIELD_NUMBER = 1;
  private int x_ = 0;
  /**
   * <pre>
   * Corresponds to the x and y coordinate of the window geometry. The window
   * geometry includes the window frame.
   * See: https://doc.qt.io/qt-5/application-windows.html#window-geometry for
   * details and pecularities on linux.
   * </pre>
   *
   * <code>uint32 x = 1;</code>
   * @return The x.
   */
  @java.lang.Override
  public int getX() {
    return x_;
  }

  public static final int Y_FIELD_NUMBER = 2;
  private int y_ = 0;
  /**
   * <code>uint32 y = 2;</code>
   * @return The y.
   */
  @java.lang.Override
  public int getY() {
    return y_;
  }

  public static final int HORIZONTALANCHOR_FIELD_NUMBER = 3;
  private int horizontalAnchor_ = 0;
  /**
   * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
   * @return The enum numeric value on the wire for horizontalAnchor.
   */
  @java.lang.Override public int getHorizontalAnchorValue() {
    return horizontalAnchor_;
  }
  /**
   * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
   * @return The horizontalAnchor.
   */
  @java.lang.Override public com.android.emulator.control.WindowPosition.HorizontalAnchor getHorizontalAnchor() {
    com.android.emulator.control.WindowPosition.HorizontalAnchor result = com.android.emulator.control.WindowPosition.HorizontalAnchor.forNumber(horizontalAnchor_);
    return result == null ? com.android.emulator.control.WindowPosition.HorizontalAnchor.UNRECOGNIZED : result;
  }

  public static final int VERTICALANCHOR_FIELD_NUMBER = 4;
  private int verticalAnchor_ = 0;
  /**
   * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
   * @return The enum numeric value on the wire for verticalAnchor.
   */
  @java.lang.Override public int getVerticalAnchorValue() {
    return verticalAnchor_;
  }
  /**
   * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
   * @return The verticalAnchor.
   */
  @java.lang.Override public com.android.emulator.control.WindowPosition.VerticalAnchor getVerticalAnchor() {
    com.android.emulator.control.WindowPosition.VerticalAnchor result = com.android.emulator.control.WindowPosition.VerticalAnchor.forNumber(verticalAnchor_);
    return result == null ? com.android.emulator.control.WindowPosition.VerticalAnchor.UNRECOGNIZED : result;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (x_ != 0) {
      output.writeUInt32(1, x_);
    }
    if (y_ != 0) {
      output.writeUInt32(2, y_);
    }
    if (horizontalAnchor_ != com.android.emulator.control.WindowPosition.HorizontalAnchor.LEFT.getNumber()) {
      output.writeEnum(3, horizontalAnchor_);
    }
    if (verticalAnchor_ != com.android.emulator.control.WindowPosition.VerticalAnchor.TOP.getNumber()) {
      output.writeEnum(4, verticalAnchor_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (x_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeUInt32Size(1, x_);
    }
    if (y_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeUInt32Size(2, y_);
    }
    if (horizontalAnchor_ != com.android.emulator.control.WindowPosition.HorizontalAnchor.LEFT.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(3, horizontalAnchor_);
    }
    if (verticalAnchor_ != com.android.emulator.control.WindowPosition.VerticalAnchor.TOP.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(4, verticalAnchor_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.android.emulator.control.WindowPosition)) {
      return super.equals(obj);
    }
    com.android.emulator.control.WindowPosition other = (com.android.emulator.control.WindowPosition) obj;

    if (getX()
        != other.getX()) return false;
    if (getY()
        != other.getY()) return false;
    if (horizontalAnchor_ != other.horizontalAnchor_) return false;
    if (verticalAnchor_ != other.verticalAnchor_) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + X_FIELD_NUMBER;
    hash = (53 * hash) + getX();
    hash = (37 * hash) + Y_FIELD_NUMBER;
    hash = (53 * hash) + getY();
    hash = (37 * hash) + HORIZONTALANCHOR_FIELD_NUMBER;
    hash = (53 * hash) + horizontalAnchor_;
    hash = (37 * hash) + VERTICALANCHOR_FIELD_NUMBER;
    hash = (53 * hash) + verticalAnchor_;
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.android.emulator.control.WindowPosition parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.android.emulator.control.WindowPosition parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.WindowPosition parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.WindowPosition parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.android.emulator.control.WindowPosition prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * The pixel coordinates are resolution independent, meaning the coordinates
   * are independent from the pixel grid, resulting in a graphical user
   * interface that is displayed at a consistent location, regardless of the
   * resolution of the screen.
   *
   * For technical details: https://doc.qt.io/qt-5/highdpi.html
   *
   * Some things to note:
   *
   * - You cannot move a window offscreen.
   * - There is a padding of around 10px around the frame.
   *
   * This means that moving to (0, 0) or (10, 10) will have the same result.
   * This means that anchoring might not exactly behave as requested.
   * </pre>
   *
   * Protobuf type {@code android.emulation.control.WindowPosition}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:android.emulation.control.WindowPosition)
      com.android.emulator.control.WindowPositionOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.android.emulator.control.UiControllerService.internal_static_android_emulation_control_WindowPosition_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.android.emulator.control.UiControllerService.internal_static_android_emulation_control_WindowPosition_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.android.emulator.control.WindowPosition.class, com.android.emulator.control.WindowPosition.Builder.class);
    }

    // Construct using com.android.emulator.control.WindowPosition.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      x_ = 0;
      y_ = 0;
      horizontalAnchor_ = 0;
      verticalAnchor_ = 0;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.android.emulator.control.UiControllerService.internal_static_android_emulation_control_WindowPosition_descriptor;
    }

    @java.lang.Override
    public com.android.emulator.control.WindowPosition getDefaultInstanceForType() {
      return com.android.emulator.control.WindowPosition.getDefaultInstance();
    }

    @java.lang.Override
    public com.android.emulator.control.WindowPosition build() {
      com.android.emulator.control.WindowPosition result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.android.emulator.control.WindowPosition buildPartial() {
      com.android.emulator.control.WindowPosition result = new com.android.emulator.control.WindowPosition(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(com.android.emulator.control.WindowPosition result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.x_ = x_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.y_ = y_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.horizontalAnchor_ = horizontalAnchor_;
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.verticalAnchor_ = verticalAnchor_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.android.emulator.control.WindowPosition) {
        return mergeFrom((com.android.emulator.control.WindowPosition)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.android.emulator.control.WindowPosition other) {
      if (other == com.android.emulator.control.WindowPosition.getDefaultInstance()) return this;
      if (other.getX() != 0) {
        setX(other.getX());
      }
      if (other.getY() != 0) {
        setY(other.getY());
      }
      if (other.horizontalAnchor_ != 0) {
        setHorizontalAnchorValue(other.getHorizontalAnchorValue());
      }
      if (other.verticalAnchor_ != 0) {
        setVerticalAnchorValue(other.getVerticalAnchorValue());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              x_ = input.readUInt32();
              bitField0_ |= 0x00000001;
              break;
            } // case 8
            case 16: {
              y_ = input.readUInt32();
              bitField0_ |= 0x00000002;
              break;
            } // case 16
            case 24: {
              horizontalAnchor_ = input.readEnum();
              bitField0_ |= 0x00000004;
              break;
            } // case 24
            case 32: {
              verticalAnchor_ = input.readEnum();
              bitField0_ |= 0x00000008;
              break;
            } // case 32
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private int x_ ;
    /**
     * <pre>
     * Corresponds to the x and y coordinate of the window geometry. The window
     * geometry includes the window frame.
     * See: https://doc.qt.io/qt-5/application-windows.html#window-geometry for
     * details and pecularities on linux.
     * </pre>
     *
     * <code>uint32 x = 1;</code>
     * @return The x.
     */
    @java.lang.Override
    public int getX() {
      return x_;
    }
    /**
     * <pre>
     * Corresponds to the x and y coordinate of the window geometry. The window
     * geometry includes the window frame.
     * See: https://doc.qt.io/qt-5/application-windows.html#window-geometry for
     * details and pecularities on linux.
     * </pre>
     *
     * <code>uint32 x = 1;</code>
     * @param value The x to set.
     * @return This builder for chaining.
     */
    public Builder setX(int value) {

      x_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Corresponds to the x and y coordinate of the window geometry. The window
     * geometry includes the window frame.
     * See: https://doc.qt.io/qt-5/application-windows.html#window-geometry for
     * details and pecularities on linux.
     * </pre>
     *
     * <code>uint32 x = 1;</code>
     * @return This builder for chaining.
     */
    public Builder clearX() {
      bitField0_ = (bitField0_ & ~0x00000001);
      x_ = 0;
      onChanged();
      return this;
    }

    private int y_ ;
    /**
     * <code>uint32 y = 2;</code>
     * @return The y.
     */
    @java.lang.Override
    public int getY() {
      return y_;
    }
    /**
     * <code>uint32 y = 2;</code>
     * @param value The y to set.
     * @return This builder for chaining.
     */
    public Builder setY(int value) {

      y_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <code>uint32 y = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearY() {
      bitField0_ = (bitField0_ & ~0x00000002);
      y_ = 0;
      onChanged();
      return this;
    }

    private int horizontalAnchor_ = 0;
    /**
     * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
     * @return The enum numeric value on the wire for horizontalAnchor.
     */
    @java.lang.Override public int getHorizontalAnchorValue() {
      return horizontalAnchor_;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
     * @param value The enum numeric value on the wire for horizontalAnchor to set.
     * @return This builder for chaining.
     */
    public Builder setHorizontalAnchorValue(int value) {
      horizontalAnchor_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
     * @return The horizontalAnchor.
     */
    @java.lang.Override
    public com.android.emulator.control.WindowPosition.HorizontalAnchor getHorizontalAnchor() {
      com.android.emulator.control.WindowPosition.HorizontalAnchor result = com.android.emulator.control.WindowPosition.HorizontalAnchor.forNumber(horizontalAnchor_);
      return result == null ? com.android.emulator.control.WindowPosition.HorizontalAnchor.UNRECOGNIZED : result;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
     * @param value The horizontalAnchor to set.
     * @return This builder for chaining.
     */
    public Builder setHorizontalAnchor(com.android.emulator.control.WindowPosition.HorizontalAnchor value) {
      if (value == null) {
        throw new NullPointerException();
      }
      bitField0_ |= 0x00000004;
      horizontalAnchor_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.HorizontalAnchor horizontalAnchor = 3;</code>
     * @return This builder for chaining.
     */
    public Builder clearHorizontalAnchor() {
      bitField0_ = (bitField0_ & ~0x00000004);
      horizontalAnchor_ = 0;
      onChanged();
      return this;
    }

    private int verticalAnchor_ = 0;
    /**
     * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
     * @return The enum numeric value on the wire for verticalAnchor.
     */
    @java.lang.Override public int getVerticalAnchorValue() {
      return verticalAnchor_;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
     * @param value The enum numeric value on the wire for verticalAnchor to set.
     * @return This builder for chaining.
     */
    public Builder setVerticalAnchorValue(int value) {
      verticalAnchor_ = value;
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
     * @return The verticalAnchor.
     */
    @java.lang.Override
    public com.android.emulator.control.WindowPosition.VerticalAnchor getVerticalAnchor() {
      com.android.emulator.control.WindowPosition.VerticalAnchor result = com.android.emulator.control.WindowPosition.VerticalAnchor.forNumber(verticalAnchor_);
      return result == null ? com.android.emulator.control.WindowPosition.VerticalAnchor.UNRECOGNIZED : result;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
     * @param value The verticalAnchor to set.
     * @return This builder for chaining.
     */
    public Builder setVerticalAnchor(com.android.emulator.control.WindowPosition.VerticalAnchor value) {
      if (value == null) {
        throw new NullPointerException();
      }
      bitField0_ |= 0x00000008;
      verticalAnchor_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>.android.emulation.control.WindowPosition.VerticalAnchor verticalAnchor = 4;</code>
     * @return This builder for chaining.
     */
    public Builder clearVerticalAnchor() {
      bitField0_ = (bitField0_ & ~0x00000008);
      verticalAnchor_ = 0;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:android.emulation.control.WindowPosition)
  }

  // @@protoc_insertion_point(class_scope:android.emulation.control.WindowPosition)
  private static final com.android.emulator.control.WindowPosition DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.android.emulator.control.WindowPosition();
  }

  public static com.android.emulator.control.WindowPosition getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<WindowPosition>
      PARSER = new com.google.protobuf.AbstractParser<WindowPosition>() {
    @java.lang.Override
    public WindowPosition parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<WindowPosition> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<WindowPosition> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.android.emulator.control.WindowPosition getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

